Manage showcase API processes
Create Showcase & Creative ("Happy" Path)
Description
Organization that is a location owner or delegated partner creates a showcase, targeting a single location, and a showcase creative. The location owner has its own app and adds a call-to-action that's expected to invoke their app in Apple Maps.
Preconditions
- Organization's brand is approved
- API user has successfully created a location which includes action link details (quicklinks)
- Targeted location's resource state is
PUBLISHED, or the location has a version that was previouslyPUBLISHED. If the location has never beenPUBLISHED, wait until it is before you create the showcase. Otherwise, the showcase will fail to publish.
note
Refer to Create Resource sequence diagram for information on how to create a location
Add Image
- API user requests image upload
- Service validates request
- If no exceptions, then
202 Acceptedis returned - Response body includes image
id
Get (Image) Metadata
- Using the
imageIdreturned in a previous steps, the API user requests* image metadata to check resource state - Service validates request
- If no exceptions, then
200 OKis returned - If response body's resource state is
APPROVED, then API user may proceed. Else, API user periodically calls the service untilAPPROVEDis indicated before proceeding
Get Call-to-Action
- API user requests a list of available call-to-action types which exist at the time of request
- Service validates request
- If no exceptions, then
200 OKis returned - Response body include a list of available call-to-action types
Create Showcase Creative
- API user requests creation of showcase creative
- photo
idis set using the imageidreturned by the Get Metadata service callToActionis set using a singletypereturned by the Get CTAs service Optionally, passing inappIds- All other mandatory fields are set
- Service validates request
- System synchronously validates partner data
- If no exceptions, then
201 Createdis returned - System asynchronously validates partner data
- If no exceptions, then Feedback is not generated
- Showcase creative moves to
IN_REVIEWstate - Service "listens" for event indicating resource is
APPROVED - Service captures Feedback and generates Notification when event message is received
- Periodically API user requests Notifications
- Notification indicates that resource is
APPROVED
tip
Poll for notifications every 15 minutes
Get Location
- Using the
idof the targeted location, the API user requests the location to check its resource state - Service validates request
- If no exceptions, then
200 OKis returned - If response body's resource state is
PUBLISHED, or the location has previously beenPUBLISHED, then API user may proceed. Else, API user periodically calls the service untilPUBLISHEDis indicated before proceeding
Create Showcase
- API user requests creation of showcase
creativeIdis set using theidof the Showcase Creative in a previous stepsresourceIdis set using theidof the targeted Location
- Service validates request
- System synchronously validates partner data
- If no exceptions, then
201 Createdis returned - System asynchronously validates partner data
- If no exceptions, then Feedback is not generated
- Showcase moves to
IN_REVIEWstate - Service "listens" for event indicating resource is
APPROVED - Service captures Feedback and generates Notification when event message is received
- Periodically API user requests Notifications
- Notification indicates that resource is
APPROVED
tip
Poll for notifications every 15 minutes
note
If the targeted location has never been PUBLISHED when the Showcase publication process is initiated, the Showcase moves to REJECTED and is not resubmitted when the location is later published. After the location is PUBLISHED, update the Showcase to resubmit it. Refer to Resource ID for details.